;;PS4.SCM                                               12:15pm, 10 October

;;MIT 6.001                                             Fall 1997


      ;; to be redefined:

(define make-table cons)
(define col-names-of car)
(define row-of cdr)

;(define (rename-column table name1 name2)
;  ...)


(define mk-env list)
(define vars-of car)
(define vals-of cadr)


(define EVENTS
  (make-table
   '(EVENT                          CAFEMEISTER  HOURS  RUNNERUP   RU-HOURS)
   '((Netscape-Pro-Am                    Ben      9      Alyssa      6)
     (Micrsft-Explrr-Invitatnl           Lem-E    10     Ben         9)
     (Capuccino-Cup                      Eva-Lu   7      Cy-D        6)
     (Juan-Valdez-Challenge              Louis    15     Eva-Lu      9)
     (Seattle-Sleepless-Masters          Louis    19     Cy-D        15)
     (Tour-de-Caffeine                   Alyssa   28     Lem-E       24)
     (Espresso-Express                   Eva-Lu   15     Ben         10)
     (Coupe-Mondial                      Alyssa   17     Gerry       12)
     (End-of-Term-Grand-Slam             Alyssa   30     Louis       28))))

(define ATHLETES
  (make-table
   '(NAME               SPONSOR                    LAST-YR-WSCDI-RANK)
   '((Ben               Starbucks                  3)
     (Alyssa            seven-11                   4)
     (Cy-D              Coffee-Connection          6)
     (Lem-E             Green-Mountain             2)
     (Louis             LaVerdes                   5)
     (Eva-Lu            Coffee-Connection          7)
     (Gerry             Starbucks                  1))))


(define filter
  (lambda (pred lst)
    (cond
     ((null? lst) '())
     ((pred (car lst))
      (cons (car lst)
	    (filter pred (cdr lst))))
     (else
      (filter pred (cdr lst))))))

(define (tensor x-list y-list op)
    (map (lambda (x)
           (map (lambda (y) (op x y))
                y-list))
         x-list))

(define variable? symbol?)

(define (value? e)
  (or (atomic-value? e)
      (symbol-value? e)))

(define (atomic-value? e)
  (or (number? e)
      (boolean? e)
      (string? e)))

(define (symbol-value? e)
  (and (pair? e)
       (eq? (car e) 'quote)
       (and (pair? (cdr e))
            (symbol? (cadr e))
            (null? (cddr e)))))

(define (quoted-val e)        ;e must be a symbol-value
        (cadr e))

(define (op-of e) (car e))
(define (arg1-of e) (cadr e))
(define (arg2-of e) (caddr e))


(define (evaluate expr env)
  (cond
   ((variable? expr)
    (lookup expr env))
   ((atomic-value? expr) expr)
   ((symbol-value? expr) (quoted-val expr))
   (else                  ;expr is of the form (op exp1 exp2)
    (let ((primitive-op (lookup (op-of expr) op-table))
          (val1 (evaluate (arg1-of expr) env))
          (val2 (evaluate (arg2-of expr) env)))
      (primitive-op val1 val2)))))


;;; *********************************************
;;; Incomplete fragments to be filled out as part of the PS


;(define (rename-column table name1 name2)
;  ...)

;(define lookup
;  (lambda (var env)
;    ...))

;(define v-slice-row
;  (lambda (cols col-names row)
;    ...))

;(define v-slice
;  (lambda (cols table)
;    ...))


;(define h-slice
;  (lambda (pred table)
;    ...))

;(define op-table ...


;(define (join table1 table2)
;       ...))))

;(define (join+ table1 table2)
;        ...))))



;;; -------------------------------------------------
;;; Example queries for testing
;;;

(define Q1 (lambda ()
	     (v-slice '(event cafemeister runnerup)
		      EVENTS)))

(define Q2 (lambda ()
	     (h-slice '(eq? sponsor 'Starbucks)
  		      ATHLETES)))

(define Q3 (lambda ()
	     (v-slice '(event cafemeister)
		      (h-slice '(= hours (+ ru-hours 3))
			       EVENTS))))

(define Q4 (lambda ()
	     (v-slice '(event)
		      (h-slice '(eq? sponsor 'Starbucks)
			       (h-slice '(eq? cafemeister name)
				        (join EVENTS ATHLETES))))))

(define Q5 (lambda ()
	     (v-slice '(event)
		      (h-slice '(and (eq? sponsor 'Starbucks)
				     (eq? cafemeister name))
			       (join EVENTS ATHLETES)))))

(define Q6 (lambda ()
	     (v-slice '(event)
		      (h-slice '(eq? cafemeister name)
			       (join EVENTS
				     (h-slice '(eq? sponsor 'Starbucks)
					      ATHLETES))))))

(define Q7 (lambda ()
	     (v-slice '(cafemeister event)
		      (h-slice '(> hours 8)
			       (h-slice '(eq? cafemeister name)
				       (h-slice '(< last-yr-wscdi-rank 3)
					        (join EVENTS
						      ATHLETES)))))))
